| Fast routine for printing an unsigned long in hexadecimal (uppercase
| letters).
| Also, there is a size optimization when d0 = 0.
|
| Copyright  2002-2004 Lionel Debroux, designed for TIGCCLIB.

.data
        .xdef itoa_ulong_16_lower
        .even
itoa_ulong_16_lower:
        move.l   %d3,-(%sp)
        moveq    #0xF,%d3
        pea      (%a0)
        lea      __itoa_16L_table__,%a1
        moveq    #8-1,%d2

        tst.l    %d0
        beq.s    __iul16l_zero__
        
        swap     %d0
        tst.w    %d0
        bne.s    _iul16l_loop1__
| Upper part of d0 is clear, so execute the loops (8-1)-4 times.
        subq.w   #4,%d2
        bra.s    __iul16l_loop1__
_iul16l_loop1__:
        swap     %d0
__iul16l_loop1__:
        rol.l    #4,%d0
        move.w   %d0,%d1
        and.w    %d3,%d1
        dbne     %d2,__iul16l_loop1__
        bra.s    __iul16l_loop2__

__iul16l_zero__:
| d0 = 0 (size optimization at the expense of speed).
        moveq    #0,%d2

_iul16l_loop2__:
        rol.l    #4,%d0
        move.w   %d0,%d1
        and.w    %d3,%d1
__iul16l_loop2__:
        move.b   0(%a1,%d1.w),(%a0)+
        dbf      %d2,_iul16l_loop2__
        
        move.l   %a0,%d0
        sub.l    (%sp)+,%d0
        move.l   (%sp)+,%d3

        clr.b    (%a0)
        rts
